/* Copyright 1990 GROUPE BULL -- See licence conditions in file COPYRIGHT */
/* XCrPFData.c:
 *
 *  XPM
 *  Create from Data utility for XPM file format
 *  Developed by Arnaud Le Hors
 */

#include "xpmP.h"

int XCreatePixmapFromData(display, visual, d, colormap, data, depth,
			  pixmap_return, width_return, height_return, 
			  pixels_return, npixels_return,
			  colorsymbols, numsymbols, infos)
     Display *display;
     Visual *visual;
     Drawable d;
     Colormap colormap;
     char **data;
     unsigned int depth;
     Pixmap *pixmap_return;
     unsigned int *width_return, *height_return, *npixels_return;
     Pixel **pixels_return;
     ColorSymbol colorsymbols[];
     unsigned int numsymbols;
     XpmInfo *infos;

{ MData *mdata;
  int ErrorStatus;

  /* Initialize return values
   */
  if (pixmap_return) *pixmap_return = NULL;
  if (width_return) *width_return = 0;
  if (height_return) *height_return = 0;
  if (pixels_return) *pixels_return = NULL;
  if (npixels_return) *npixels_return = 0;

  if ((ErrorStatus = mdataopen(data, &mdata)) != PixmapSuccess)
      return(ErrorStatus);

  ErrorStatus = CreatePixmap(display, visual, d, colormap, mdata, depth,
			     pixmap_return, width_return, height_return, 
			     pixels_return, npixels_return,
			     colorsymbols, numsymbols, infos);
  mclose(mdata);
  return(ErrorStatus);
}
